//+------------------------------------------------------------------+
//|                                           VininI_Stoch_Alert.mq4 |
//|                                Copyright  2008, Victor Nicolaev |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "vinin@mail.ru"


#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LightSeaGreen
#property indicator_color2 Red

#property indicator_maximum 100
#property indicator_minimum   0

extern int     Kperiod     = 5;
extern int     Dperiod     = 3;
extern int     slowing     = 3;
extern int     method      = 0; // 0 - SMA, 1- EMA, 2 - 
extern int     price_field = 0; // 0 - High/Low; 1 - Close/Close
extern double Level1=80;
extern double Level2=50;
extern double Level3=20;
extern int pos=1;
extern bool bAlert=false;
extern bool bSound=false;
extern string NameFileSound="alert.wav";

//---- buffers

double Stoch[];
double Signal[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,0);

   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,0);

   SetIndexBuffer(0,Stoch);
   SetIndexBuffer(1,Signal);

   return(0); }//int init() 
//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   int i, j,k;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for (i = limit;i>=0;i--){
      Stoch[i]=iStochastic(NULL,0,Kperiod,Dperiod,slowing,method,price_field,MODE_MAIN,i);
      Signal[i]=iStochastic(NULL,0,Kperiod,Dperiod,slowing,method,price_field,MODE_SIGNAL,i);

   }
   if (NevBar()) {
      if ((Stoch[pos+1]-Level1)*(Level1-Stoch[pos])<=0 ||
         (Stoch[pos+1]-Level2)*(Level2-Stoch[pos])<=0 ||
         (Stoch[pos+1]-Level3)*(Level3-Stoch[pos])<=0) {
      
         if (bAlert) Alert("");
         if (bSound) PlaySound(NameFileSound); 
      }
   }
   return(0); 
}


//===============================================================================
//    
//===============================================================================
bool NevBar(){
   static int PrevTime=0;
   if (PrevTime==Time[0]) return(false);
   PrevTime=Time[0];
   return(true);
}


